# sbcgen

A small static blog generator in python. This was written for [my own blog](https://steveblock.com) which ran on [jekyll](https://jekyllrb.com/) for years, but I had some trouble getting jekyll running properly on a new host because of stupid ruby requirements and broken gems. After looking around at a bunch of other existing options I realized I needed minimal features and so rebuilt just the parts I was using in python.

Reads files from a few specific paths which are set in `_config.yaml`. It converts all markdown files in the defined blog folder to individual publishing folders at `/post-slug/index.html`. It converts all other markdown files outside the blog path from `filename.md` to `filename.html`. It copies all other files as is to the publishing folder. This folder is set in `_config.yaml`.

Ignores any file or folder starting with an underscore.

Default paths:
- `_posts`: blog posts titled as yyyy-mm-dd-post-slug.md
- `_templates`: jinja and xml templates for pages and atom feeds

## Requirements
- Python 3.9 or later (earliest tested version, likely works on any Python 3 release)
- [Pyyaml](https://pyyaml.org/wiki/PyYAMLDocumentation)
- [jinja template engine](https://pypi.org/project/Jinja2/)
- [frontmatter](https://pypi.org/project/python-frontmatter/)
- [Python markdown](https://github.com/Python-Markdown/markdown)
- A web host set up to read index.html as default files

## Usage

`sitegen [all/blog/static/sitemap]`

If run without options will rebuild only the blog. Otherwise can be set to generate only the blog, only the static pages, or all pages.

Sitemap is only built with build all, or build sitemap